Package ghidra.app.util.bin.format.dwarf.macro

# Enum Class DWARFMacroOpcode

java.lang.Object
java.lang.Enum<DWARFMacroOpcode>
ghidra.app.util.bin.format.dwarf.macro.DWARFMacroOpcode

All Implemented Interfaces:
  `Serializable`, `Comparable<DWARFMacroOpcode>`, `Constable`

public enum DWARFMacroOpcode extends Enum<DWARFMacroOpcode>
DWARF macro entry opcodes and their expected operand types.

DWARF5

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static class`
  `DWARFMacroOpcode.Def`

  ## Nested classes/interfaces inherited from class java.lang.Enum

  `Enum.EnumDesc<E extends Enum<E>>`

- ## Enum Constant Summary

  Enum Constants
  Enum Constant
  Description
  `DW_MACRO_define`
  `DW_MACRO_define_strp`
  `DW_MACRO_define_strx`
  `DW_MACRO_define_sup`
  `DW_MACRO_end_file`
  `DW_MACRO_import`
  `DW_MACRO_import_sup`
  `DW_MACRO_start_file`
  `DW_MACRO_undef`
  `DW_MACRO_undef_strp`
  `DW_MACRO_undef_strx`
  `DW_MACRO_undef_sup`
  `MACRO_UNIT_TERMINATOR`
  This is not an official opcode in the DWARF standard, but represents the entry with opcode 0 that terminates a macro unit.

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final Map<Integer,List<DWARFForm>>`
  `defaultOpcodeOperandMap`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `String`
  `getDescription()`
  `DWARFForm[]`
  `getOperandForms()`
  `int`
  `getRawOpcode()`
  `static DWARFMacroOpcode`
  `of(int opcodeVal)`
  `static DWARFMacroOpcode`
  `valueOf(String name)`
  Returns the enum constant of this class with the specified name.
  `static DWARFMacroOpcode[]`
  `values()`
  Returns an array containing the constants of this enum class, in the order they are declared.

  ### Methods inherited from class java.lang.Enum

  `clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

  ### Methods inherited from class java.lang.Object

  `getClass, notify, notifyAll, wait, wait, wait`

- ## Enum Constant Details

  - ### MACRO_UNIT_TERMINATOR

    public static final DWARFMacroOpcode MACRO_UNIT_TERMINATOR
    This is not an official opcode in the DWARF standard, but represents the entry with opcode 0 that terminates a macro unit.

  - ### DW_MACRO_define

    public static final DWARFMacroOpcode DW_MACRO_define

  - ### DW_MACRO_undef

    public static final DWARFMacroOpcode DW_MACRO_undef

  - ### DW_MACRO_start_file

    public static final DWARFMacroOpcode DW_MACRO_start_file

  - ### DW_MACRO_end_file

    public static final DWARFMacroOpcode DW_MACRO_end_file

  - ### DW_MACRO_define_strp

    public static final DWARFMacroOpcode DW_MACRO_define_strp

  - ### DW_MACRO_undef_strp

    public static final DWARFMacroOpcode DW_MACRO_undef_strp

  - ### DW_MACRO_import

    public static final DWARFMacroOpcode DW_MACRO_import

  - ### DW_MACRO_define_sup

    public static final DWARFMacroOpcode DW_MACRO_define_sup

  - ### DW_MACRO_undef_sup

    public static final DWARFMacroOpcode DW_MACRO_undef_sup

  - ### DW_MACRO_import_sup

    public static final DWARFMacroOpcode DW_MACRO_import_sup

  - ### DW_MACRO_define_strx

    public static final DWARFMacroOpcode DW_MACRO_define_strx

  - ### DW_MACRO_undef_strx

    public static final DWARFMacroOpcode DW_MACRO_undef_strx

- ## Field Details

  - ### defaultOpcodeOperandMap

    public static final Map<Integer,List<DWARFForm>> defaultOpcodeOperandMap

- ## Method Details

  - ### values

    public static DWARFMacroOpcode[] values()
    Returns an array containing the constants of this enum class, in the order they are declared.
    Returns:
      an array containing the constants of this enum class, in the order they are declared

  - ### valueOf

    public static DWARFMacroOpcode valueOf(String name)
    Returns the enum constant of this class with the specified name. The string must match exactly an identifier used to declare an enum constant in this class. (Extraneous whitespace characters are not permitted.)
    Parameters:
      `name` - the name of the enum constant to be returned.
    Returns:
      the enum constant with the specified name
    Throws:
      `IllegalArgumentException` - if this enum class has no constant with the specified name
      `NullPointerException` - if the argument is null

  - ### getRawOpcode

    public int getRawOpcode()

  - ### getDescription

    public String getDescription()

  - ### getOperandForms

    public DWARFForm[] getOperandForms()

  - ### of

    public static DWARFMacroOpcode of(int opcodeVal)